// ******************************************************
// 
//          Sliderpusher for Digital Painters
//
//           Designed for Arduino Pro Micro
//     and licensed under CC BY-NC-SA 3.0 by Rhoius
//  
//             For more information go to:
//     https://www.instructables.com/member/rhoius/
//
// ******************************************************

#include "Keyboard.h"

//defining encoder pins
#define enc0A 4
#define enc0B 1
#define enc0S 16

#define enc1A 5
#define enc1B 0
#define enc1S 14

#define enc2A 7
#define enc2B 2
#define enc2S 15

#define enc3A 8
#define enc3B 3
#define enc3S 18

//defining auxiliary switches
#define auxsw0 19
#define auxsw1 20
#define auxsw2 21

//defining PWM pins to drive RGB
#define pwmR 6
#define pwmG 9
#define pwmB 10

//setting the default keymap (1-3)
int keymap = 2;

//KEYBINDS

//encoder 0 keybinds
void enc0ccw() // encoder0 / CCW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F19);
    
    Keyboard.releaseAll();
  
    //Serial.print("encoder0 CCW");
    //Serial.println(" ");
}
void enc0cw() // encoder0 / CW
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F19);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder0 CW");
    //Serial.println(" ");
}

// keymap1 
void enc1ccw1() // keymap1 / encoder1 / CCW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F13);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CCW (keymap1)");
    //Serial.println(" ");
}
void enc1cw1() // keymap1 / encoder1 / CW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F14);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CW  (keymap1)");
    //Serial.println(" ");
}
void enc2ccw1() // keymap1 / encoder2 / CCW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F15);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CCW (keymap1)");
    //Serial.println(" ");
}
void enc2cw1() // keymap1 / encoder2 / CW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F16);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CW  (keymap1)");
    //Serial.println(" ");
}
void enc3ccw1() // keymap1 / encoder3 / CCW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F17);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CCW (keymap1)");
    //Serial.println(" ");
}
void enc3cw1() // keymap1 / encoder3 / CW
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_F18);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CW  (keymap1)");
    //Serial.println(" ");
}

// keymap2
void enc1ccw2() // keymap2 / encoder1 / CCW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F13);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CCW (keymap2)");
    //Serial.println(" ");
}
void enc1cw2() // keymap2 / encoder1 / CW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F14);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CW  (keymap2)");
    //Serial.println(" ");
}
void enc2ccw2() // keymap2 / encoder2 / CCW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F15);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CCW (keymap2)");
    //Serial.println(" ");
}
void enc2cw2() // keymap2 / encoder2 / CW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F16);
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CW  (keymap2)");
    //Serial.println(" ");
}
void enc3ccw2() // keymap2 / encoder3 / CCW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F17);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CCW (keymap2)");
    //Serial.println(" ");
}
void enc3cw2() // keymap2 / encoder3 / CW 
{
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F18);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CW  (keymap2)");
    //Serial.println(" ");
}

//keymap 3
void enc1ccw3() // keymap3 / encoder1 / CCW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F13);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CCW (keymap3)");
    //Serial.println(" ");
}
void enc1cw3() // keymap3 / encoder1 / CW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F14);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder1 CW  (keymap3)");
    //Serial.println(" ");
}
void enc2ccw3() // keymap3 / encoder2 / CCW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F15);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CCW (keymap3)");
    //Serial.println(" ");
}
void enc2cw3() // keymap3 / encoder2 / CW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F16);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder2 CW  (keymap3)");
    //Serial.println(" ");
}
void enc3ccw3() // keymap3 / encoder3 / CCW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F17);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CCW (keymap3)");
    //Serial.println(" ");
}
void enc3cw3() // keymap3 / encoder3 / CW 
{
    Keyboard.press(KEY_LEFT_CTRL);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_F18);
    
    Keyboard.releaseAll();
    
    //Serial.print("encoder3 CW  (keymap3)");
    //Serial.println(" ");
}

//encoder push switches
void enc0sd()
{
      Keyboard.press(KEY_F16);
      
      while (digitalRead(enc0S) == 0) {
        delay(50);
      }
      Keyboard.releaseAll();  
      //Serial.print("encoder0 switch");
      //Serial.println(" ");      
}
void enc1sd()
{     
      Keyboard.press(KEY_F13);
      
      while (digitalRead(enc1S) == 0) {
        delay(50);
      }
      Keyboard.releaseAll();
      keymap = 1;      
      //Serial.print("encoder1 switch");
      //Serial.println(" ");      
}
void enc2sd()
{
      Keyboard.press(KEY_F14);
      
      while (digitalRead(enc2S) == 0) {
        delay(50);
      }      
      Keyboard.releaseAll();
      keymap = 2;      
      //Serial.print("encoder2 switch");
      //Serial.println(" ");       
}
void enc3sd()
{
      Keyboard.press(KEY_F15);
      
      while (digitalRead(enc3S) == 0) {
        delay(50);
      }      
      Keyboard.releaseAll();     
      keymap = 3;      
      //Serial.print("encoder3 switch");
      //Serial.println(" ");      
}

//auxillary switches
void auxsw0d() //aux switch 0
{
      Keyboard.press(KEY_F17);
      
      while (digitalRead(auxsw0) == 0) {
        delay(50);
      }      
      Keyboard.releaseAll();    
      //Serial.print("aux0");
      //Serial.println(" ");      
}

void auxsw1d() //aux switch 1
{
      Keyboard.press(KEY_F18);
      
      while (digitalRead(auxsw1) == 0) {
        delay(50);
      }      
      Keyboard.releaseAll();    
      //Serial.print("aux1");
      //Serial.println(" ");      
}

void auxsw2d() //aux switch 2
{
      Keyboard.press(KEY_F19);
      
      while (digitalRead(auxsw2) == 0) {
        delay(50);
      }            
      Keyboard.releaseAll();    
      //Serial.print("aux2");
      //Serial.println(" ");      
}


//set the RGB values (0-255)
int red = 255;
int blue = 16;
int green = 0;

//
void setup() {
  
  //Serial.begin(9600);

  pinMode(enc0B, INPUT_PULLUP);
  pinMode(enc0A, INPUT_PULLUP);
  pinMode(enc0S, INPUT_PULLUP);
  
  pinMode(enc1B, INPUT_PULLUP);
  pinMode(enc1A, INPUT_PULLUP);
  pinMode(enc1S, INPUT_PULLUP);
  
  pinMode(enc2B, INPUT_PULLUP);
  pinMode(enc2A, INPUT_PULLUP);
  pinMode(enc2S, INPUT_PULLUP);

  pinMode(enc3B, INPUT_PULLUP);
  pinMode(enc3A, INPUT_PULLUP);
  pinMode(enc3S, INPUT_PULLUP);
    
  attachInterrupt(digitalPinToInterrupt(enc0B), enc0isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(enc1B), enc1isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(enc2B), enc2isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(enc3B), enc3isr, CHANGE);

  pinMode(auxsw0, INPUT_PULLUP);
  pinMode(auxsw1, INPUT_PULLUP);
  pinMode(auxsw2, INPUT_PULLUP);

  pinMode(pwmR, OUTPUT);
  pinMode(pwmG, OUTPUT);
  pinMode(pwmB, OUTPUT);

  Keyboard.begin();
  
}

//starting pulse count
int enc0p = 0; 
int enc1p = 0;
int enc2p = 0;
int enc3p = 0;
//last state of encoder A pin
int enc0Bl = 0;
int enc1Bl = 0;
int enc2Bl = 0;
int enc3Bl = 0;
//current encoder pin state variables
int enc0Bc,enc0Ac;
int enc1Bc,enc1Ac;
int enc2Bc,enc2Ac;
int enc3Bc,enc3Ac;
//current and last encoder rotation variables
int enc0rc,enc0rl;
int enc1rc,enc1rl;
int enc2rc,enc2rl;
int enc3rc,enc3rl;

void loop() {
  
//check encoder0   
  if(enc0rc<enc0rl) {
    enc0cw();
  }
  if(enc0rc>enc0rl) {
    enc0ccw();
  }

//check encoder1
  if(enc1rc<enc1rl) {
    if (keymap == 1) {
       enc1cw1();
    }
    if (keymap == 2) {
       enc1cw2();
    }
    if (keymap == 3) {
       enc1cw3();
    }

  }
  if(enc1rc>enc1rl) {
    if (keymap == 1) {
       enc1ccw1();
    }
    if (keymap == 2) {
       enc1ccw2();
    }
    if (keymap == 3) {
       enc1ccw3();
    }
  }

//check encoder2
  if(enc2rc<enc2rl) {
    if (keymap == 1) {
       enc2cw1();
    }
    if (keymap == 2) {
       enc2cw2();
    }
    if (keymap == 3) {
       enc2cw3();
    }

  }
  if(enc2rc>enc2rl) {
    if (keymap == 1) {
       enc2ccw1();
    }
    if (keymap == 2) {
       enc2ccw2();
    }
    if (keymap == 3) {
       enc2ccw3();
    }
  }

//check encoder3
  if(enc3rc<enc3rl) {
    if (keymap == 1) {
       enc3cw1();
    }
    if (keymap == 2) {
       enc3cw2();
    }
    if (keymap == 3) {
       enc3cw3();
    }

  }
  if(enc3rc>enc3rl) {
    if (keymap == 1) {
       enc3ccw1();
    }
    if (keymap == 2) {
       enc3ccw2();
    }
    if (keymap == 3) {     
       enc3ccw3();
    }
  }  

//check encoder push buttons
  if (digitalRead(enc0S) == 0) {
      enc0sd();
    }
  if (digitalRead(enc1S) == 0) {
      enc1sd();
    }
  if (digitalRead(enc2S) == 0) {
      enc2sd();
    }
  if (digitalRead(enc3S) == 0) {
      enc3sd();
    }

//check aux switches
  if (digitalRead(auxsw0) == 0) {
      auxsw0d();
    }

  if (digitalRead(auxsw1) == 0) {
      auxsw1d();
    }

  if (digitalRead(auxsw2) == 0) {
      auxsw2d();
    }


//write the RGB output
  analogWrite(pwmR, red);
  analogWrite(pwmG, green);
  analogWrite(pwmB, blue);


//updating last rotation value for all encoders
  enc0rl = enc0rc;
  enc1rl = enc1rc;
  enc2rl = enc2rc;
  enc3rl = enc3rc;  

//debouncing delay
  delay(30);
}


//interrupt service routines
void enc0isr()
{
  enc0Bc = digitalRead(enc0B);
  enc0Ac = digitalRead(enc0A);

  if ((enc0Bc == 1) and (enc0Bl == 0)) {
    if (enc0Ac == 0) {  
      enc0p++;
    }
    else {
      enc0p--;
    }
  }
  if ((enc0Bc == 0) and (enc0Bl == 1)) {
    if (enc0Ac == 0) {  
      enc0p--;
    }
    else {
      enc0p++;
    }
  }
  enc0Bl = enc0Bc;
  enc0rc = enc0p/2;
}

void enc1isr()
{
  enc1Bc = digitalRead(enc1B);
  enc1Ac = digitalRead(enc1A);

  if ((enc1Bc == 1) and (enc1Bl == 0)) {
    if (enc1Ac == 0) {  
      enc1p++;
    }
    else {
      enc1p--;
    }
  }
  if ((enc1Bc == 0) and (enc1Bl == 1)) {
    if (enc1Ac == 0) {  
      enc1p--;
    }
    else {
      enc1p++;
    }
  }
  enc1Bl = enc1Bc;
  enc1rc = enc1p/2;
}

void enc2isr()
{
  enc2Bc = digitalRead(enc2B);
  enc2Ac = digitalRead(enc2A);

  if ((enc2Bc == 1) and (enc2Bl == 0)) {
    if (enc2Ac == 0) {  
      enc2p++;
    }
    else {
      enc2p--;
    }
  }
  if ((enc2Bc == 0) and (enc2Bl == 1)) {
    if (enc2Ac == 0) {  
      enc2p--;
    }
    else {
      enc2p++;
    }
  }
  enc2Bl = enc2Bc;
  enc2rc = enc2p/2;
}

void enc3isr()
{
  enc3Bc = digitalRead(enc3B);
  enc3Ac = digitalRead(enc3A);

  if ((enc3Bc == 1) and (enc3Bl == 0)) {
    if (enc3Ac == 0) {  
      enc3p++;
    }
    else {
      enc3p--;
    }
  }
  if ((enc3Bc == 0) and (enc3Bl == 1)) {
    if (enc3Ac == 0) {  
      enc3p--;
    }
    else {
      enc3p++;
    }
  }
  enc3Bl = enc3Bc;
  enc3rc = enc3p/2;
}

//
